package com.packt.mapreduce.wordcount;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

import java.io.IOException;

public class WordcountReducer extends Reducer<Text, IntWritable, Text, IntWritable> {
    
    @Override
    protected void reduce(Text key, Iterable<IntWritable> values, Context
            context)
            throws IOException, InterruptedException {
        int count = 0;
        for (IntWritable current : values) {
            count += current.get();
        }
        context.write(key, new IntWritable(count));
    }
}
